/**
  *  \file client/chart/markermode.h
  *  \brief Starchart Mode: WMarkerChartMode
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_CHART_MARKERMODE_H
#define PCC_V2_CLIENT_CHART_MARKERMODE_H

#include "game/drawing.h"
#include "client/chartmode.h"

/** Base class for drawing manipulation chart modes. Holds a reference
    to a drawing to manipulate, a basic event handler, and constructor
    functions for the derived-class modes. */
class WMarkerChartMode : public WSimpleChartMode {
 protected:
    GDrawingContainer::iterator drawing;

 public:
    WMarkerChartMode(GDrawingContainer::iterator drawing);
    ~WMarkerChartMode();
    bool handleEvent(const UIEvent& event, GChartLocation& loc);

    static void moveMarker(WChartModeList& modes, GDrawingContainer::iterator p);
    static void drawLineRectangle(WChartModeList& modes, GDrawingContainer::iterator p);
    static void drawCircle(WChartModeList& modes, GDrawingContainer::iterator p);
    static void deleteDrawing(WChartModeList& modes, GDrawingContainer::iterator p);
};

void editMarkerComment(GDrawing& marker);

#endif
