/**
  *  \file client/dlg-draw.h
  *  \brief Drawing-related dialogs
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_DRAW_H
#define PCC_V2_CLIENT_DLG_DRAW_H

#include "game/drawing.h"
#include "ui/ui.h"
#include "ui/window.h"
#include "ui/widgets/statictext.h"

/** New drawing selection dialog */
class WNewDrawingDialog : public UIWindow {
    // User settings:
    uint8 user_color;
    atom_t tag;
    GDrawingType type;

    // UI stuff:
    ObjectHolder h;
    UIStaticText* tag_text;
    void buildDialog();
    void onTag();
    void setTag();
 public:
    WNewDrawingDialog();
    ~WNewDrawingDialog();
    bool runDialog();

    void setColor(uint8 user_color);
    uint8 getColor() const;

    void setTag(atom_t tag);
    atom_t getTag() const;

    GDrawingType getType() const;
};

#endif
