/**
  *  \file int/if/mapmsgif.h
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_INT_IF_MAPMSGIF_H
#define PCC_V2_INT_IF_MAPMSGIF_H

#include <vector>
#include "int/compound.h"
#include "int/context.h"

class IntMappedMessageValue : public IntIndexableValue {
 public:
    IntMappedMessageValue(const std::vector<int> nrs);

    // IntIndexableValue:
    IntValue* get(IntArgBlock& args);
    void set(IntArgBlock& args, IntValue* value);
    int32_t getDimension(int32_t dim);
    IntContext* makeFirstContext();

    // IntValue:
    IntMappedMessageValue* clone();
    string_t toString(bool readable);
    void store(IntTagNode& sv, Stream& aux);

    static IntMappedMessageValue* create(const std::vector<int> nrs);

 private:
    std::vector<int> nrs;
};

#endif
