#include "io/memstream.h"
#include "u/t_io.h"

#include <cstring>

static const char data[] = "some test text";

void
IoMemstreamTestSuite::testMemstream()
{
    char buf[5];

    MemoryStream ms;
    TS_ASSERT_EQUALS(ms.getSize(), 0);
    TS_ASSERT_EQUALS(ms.getPos(), 0);
    TS_ASSERT(ms.canDo(Stream::C_WRITE));
    TS_ASSERT(ms.canDo(Stream::C_READ));
    TS_ASSERT(ms.canDo(Stream::C_SEEK));
    TS_ASSERT_EQUALS(ms.write(data, sizeof data), sizeof data);
    TS_ASSERT_EQUALS(ms.getPos(), (long) sizeof data);
    TS_ASSERT_EQUALS(ms.read(buf, sizeof buf), 0U);
    TS_ASSERT_THROWS_NOTHING(ms.seek(5));
    TS_ASSERT_EQUALS(ms.getPos(), 5);
    TS_ASSERT_EQUALS(ms.read(buf, sizeof buf), sizeof buf);
    TS_ASSERT_EQUALS(std::memcmp(buf, data+5, sizeof buf), 0);
    TS_ASSERT_EQUALS(ms.getContentsAsString(), string_t(data, sizeof data));
}
